'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var path = _interopDefault(require('path'));

// src/cli.coffee
var cake;
var cakePath;
var coffeePath;
var err;
var findCake;
var nodePaths;

cake = null;

cakePath = 'coffee-script/lib/coffee-script/cake';

nodePaths = ['', '/usr/local/lib/node_modules', '/usr/lib/node_modules'];

try {
  coffeePath = require.resolve('coffee-script');
  cake = require(coffeePath.replace('coffee-script.js', 'cake'));
} catch (error) {
  err = error;
  (findCake = function() {
    if (!nodePaths.length) {
      console.error('Cannot find module \'coffee-script\'');
      process.exit(1);
    }
    try {
      return cake = require(path.join(nodePaths.shift(), cakePath));
    } catch (error) {
      err = error;
      if (err.code !== 'MODULE_NOT_FOUND') {
        throw err;
      } else {
        return findCake();
      }
    }
  })();
}

if (process.argv[2] && process.argv[2].charAt(0) !== '-') {
  process.argv.push(process.argv.splice(2, 1)[0]);
}

try {
  cake.run();
} catch (error) {
  err = error;
  if (/Cakefile not found in/.test(err.message)) {
    console.error(err.message);
  } else {
    throw err;
  }
}
//# sourceMappingURL=cli.js.map
